var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import format from '../format';
import withComponents from '../withComponents';

var identity = function identity(x) {
  return x;
};
var createSumReducer = function createSumReducer() {
  var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : identity;
  return function (acc, curr) {
    return acc + selector(curr);
  };
};
var totalPriceReducer = createSumReducer(function (x) {
  return x.price * x.amount;
});

var Cart = function (_React$PureComponent) {
  _inherits(Cart, _React$PureComponent);

  function Cart() {
    _classCallCheck(this, Cart);

    return _possibleConstructorReturn(this, _React$PureComponent.apply(this, arguments));
  }

  Cart.prototype.render = function render() {
    var _props = this.props,
        _props$onSubmit = _props.onSubmit,
        onSubmit = _props$onSubmit === undefined ? console.log : _props$onSubmit,
        cart = _props.cart,
        updateCartItem = _props.updateCartItem,
        loading = _props.loading,
        disabled = _props.disabled,
        style = _props.style,
        components = _props.components,
        otherProps = _objectWithoutProperties(_props, ['onSubmit', 'cart', 'updateCartItem', 'loading', 'disabled', 'style', 'components']);

    var View = components.View,
        Container = components.Container,
        Text = components.Text,
        Title = components.Title,
        CartItem = components.CartItem,
        Button = components.Button,
        SubmitButton = components.SubmitButton,
        UpdateCartItem = components.UpdateCartItem;


    var empty = !cart || !cart.items || !cart.items.length;
    var total = cart && !cart.items ? 0 : cart.items.reduce(totalPriceReducer, 0);
    var cartItems = cart && cart.items && cart.items.map(function (item, i) {
      return React.createElement(CartItem, {
        key: i,
        item: item,
        components: components,
        updateCartItem: updateCartItem
      });
    });

    if (loading) {
      return React.createElement(Loader, null);
    }

    return React.createElement(
      View,
      _extends({}, otherProps, { style: [styles.cartContainer].concat(style) }),
      !empty && React.createElement(
        Container,
        null,
        React.createElement(
          Title,
          null,
          format(total)
        ),
        React.createElement(
          View,
          null,
          cartItems
        )
      ),
      React.createElement(SubmitButton, { onClick: function onClick() {
          return onSubmit(cart);
        } })
    );
  };

  return Cart;
}(React.PureComponent);

var styles = {
  cartContainer: {
    flex: 1
  }
};

export default withComponents(Cart);