function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import format from '../format';
import withComponents from '../withComponents';

var CartItem = function CartItem(_ref) {
  var item = _ref.item,
      updateCartItem = _ref.updateCartItem,
      components = _ref.components,
      otherProps = _objectWithoutProperties(_ref, ['item', 'updateCartItem', 'components']);

  var Text = components.Text,
      View = components.View,
      Button = components.Button,
      UpdateCartItem = components.UpdateCartItem;


  var price = format(item.price * item.amount);

  return React.createElement(
    View,
    otherProps,
    React.createElement(UpdateCartItem, {
      item: item,
      updateCartItem: updateCartItem,
      components: components
    }),
    React.createElement(
      Text,
      null,
      item.name,
      ' - ',
      price
    )
  );
};

export default withComponents(CartItem);