var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import componentsContext from './componentsContext';
import defaults from './defaults';

var Consumer = componentsContext.Consumer;

export default function withComponents(WrappedComponent) {
  var WithComponents = function (_React$Component) {
    _inherits(WithComponents, _React$Component);

    function WithComponents() {
      _classCallCheck(this, WithComponents);

      return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    WithComponents.prototype.render = function render() {
      var _props = this.props,
          components = _props.components,
          passedProps = _objectWithoutProperties(_props, ['components']);

      return React.createElement(
        Consumer,
        null,
        function (contextComponents) {
          var passedComponents = _extends({}, defaults, contextComponents, components);
          return React.createElement(WrappedComponent, _extends({}, passedProps, {
            components: passedComponents
          }));
        }
      );
    };

    return WithComponents;
  }(React.Component);

  WithComponents.displayName = 'WithComponents(' + getDisplayName(WrappedComponent) + ')';
  return WithComponents;
}

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}