'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _format = require('../format');

var _format2 = _interopRequireDefault(_format);

var _withComponents = require('../withComponents');

var _withComponents2 = _interopRequireDefault(_withComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var CartItem = function CartItem(_ref) {
  var item = _ref.item,
      updateCartItem = _ref.updateCartItem,
      components = _ref.components,
      otherProps = _objectWithoutProperties(_ref, ['item', 'updateCartItem', 'components']);

  var Text = components.Text,
      View = components.View,
      Button = components.Button,
      UpdateCartItem = components.UpdateCartItem;


  var price = (0, _format2.default)(item.price * item.amount);

  return _react2.default.createElement(
    View,
    otherProps,
    _react2.default.createElement(UpdateCartItem, {
      item: item,
      updateCartItem: updateCartItem,
      components: components
    }),
    _react2.default.createElement(
      Text,
      null,
      item.name,
      ' - ',
      price
    )
  );
};

exports.default = (0, _withComponents2.default)(CartItem);