(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react'], factory) :
  (factory((global.ReactPdv = {}),global.React));
}(this, (function (exports,React) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var objectWithoutProperties = function (obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  var componentsContext = React.createContext(_extends({}, defaults$1));

  var Consumer = componentsContext.Consumer;

  function withComponents(WrappedComponent) {
    var WithComponents = function (_React$Component) {
      inherits(WithComponents, _React$Component);

      function WithComponents() {
        classCallCheck(this, WithComponents);
        return possibleConstructorReturn(this, _React$Component.apply(this, arguments));
      }

      WithComponents.prototype.render = function render() {
        var _props = this.props,
            components = _props.components,
            passedProps = objectWithoutProperties(_props, ['components']);

        return React.createElement(
          Consumer,
          null,
          function (contextComponents) {
            var passedComponents = _extends({}, defaults$1, contextComponents, components);
            return React.createElement(WrappedComponent, _extends({}, passedProps, {
              components: passedComponents
            }));
          }
        );
      };

      return WithComponents;
    }(React.Component);

    WithComponents.displayName = 'WithComponents(' + getDisplayName(WrappedComponent) + ')';
    return WithComponents;
  }

  function getDisplayName(WrappedComponent) {
    return WrappedComponent.displayName || WrappedComponent.name || 'Component';
  }

  var Button = function (_React$PureComponent) {
    inherits(Button, _React$PureComponent);

    function Button() {
      classCallCheck(this, Button);
      return possibleConstructorReturn(this, _React$PureComponent.apply(this, arguments));
    }

    Button.prototype.render = function render() {
      var _props = this.props,
          loading = _props.loading,
          _props$disabled = _props.disabled,
          disabled = _props$disabled === undefined ? false : _props$disabled,
          title = _props.title,
          components = _props.components,
          otherProps = objectWithoutProperties(_props, ['loading', 'disabled', 'title', 'components']);
      var BaseButton = components.BaseButton;


      return React.createElement(
        BaseButton,
        _extends({}, otherProps, {
          title: title || this.props.children || '',
          disabled: loading || disabled
        }),
        this.props.children
      );
    };

    return Button;
  }(React.PureComponent);

  var Button$1 = withComponents(Button);

  var UpdateCartItem = function UpdateCartItem(_ref) {
    var item = _ref.item,
        updateCartItem = _ref.updateCartItem,
        components = _ref.components;
    var Button = components.Button,
        Text = components.Text;

    return updateCartItem ? React.createElement(
      React.Fragment,
      null,
      React.createElement(
        Button,
        {
          disabled: item.amount <= 0,
          onClick: function onClick() {
            return updateCartItem(_extends({}, item, { amount: item.amount - 1 }));
          }
        },
        '-'
      ),
      React.createElement(
        Text,
        null,
        item.amount
      ),
      React.createElement(
        Button,
        {
          onClick: function onClick() {
            return updateCartItem(_extends({}, item, { amount: item.amount + 1 }));
          }
        },
        '+'
      )
    ) : React.createElement(
      Text,
      null,
      item.amount
    );
  };

  var UpdateCartItem$1 = withComponents(UpdateCartItem);

  var currencySymbol = 'R$';
  var thousandsDelimiter = '.';
  var hundredsDelimiter = ',';

  var format = (function (value) {
    var parts = value.toFixed(2).split('.');
    parts[0] = currencySymbol + parts[0].split(/(?=(?:...)*$)/).join(thousandsDelimiter);
    return parts.join(hundredsDelimiter);
  });

  var CartItem = function CartItem(_ref) {
    var item = _ref.item,
        updateCartItem = _ref.updateCartItem,
        components = _ref.components,
        otherProps = objectWithoutProperties(_ref, ['item', 'updateCartItem', 'components']);
    var Text = components.Text,
        View = components.View,
        Button = components.Button,
        UpdateCartItem = components.UpdateCartItem;


    var price = format(item.price * item.amount);

    return React.createElement(
      View,
      otherProps,
      React.createElement(UpdateCartItem, {
        item: item,
        updateCartItem: updateCartItem,
        components: components
      }),
      React.createElement(
        Text,
        null,
        item.name,
        ' - ',
        price
      )
    );
  };

  var CartItem$1 = withComponents(CartItem);

  var View = 'div';

  var Container = 'div';

  var Text = 'span';

  var BaseButton = 'button';

  var SafeButton = Button$1 || BaseButton;

  var SubmitButton = SafeButton;

  var defaults$1 = {
    View: View,
    Container: Container,
    Text: Text,
    BaseButton: BaseButton,
    Button: SafeButton,
    UpdateCartItem: UpdateCartItem$1,
    CartItem: CartItem$1,
    Title: Text,
    SubmitButton: SubmitButton
  };

  var defaults$2 = /*#__PURE__*/Object.freeze({
    default: defaults$1
  });

  var identity = function identity(x) {
    return x;
  };
  var createSumReducer = function createSumReducer() {
    var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : identity;
    return function (acc, curr) {
      return acc + selector(curr);
    };
  };
  var totalPriceReducer = createSumReducer(function (x) {
    return x.price * x.amount;
  });

  var Cart = function (_React$PureComponent) {
    inherits(Cart, _React$PureComponent);

    function Cart() {
      classCallCheck(this, Cart);
      return possibleConstructorReturn(this, _React$PureComponent.apply(this, arguments));
    }

    Cart.prototype.render = function render() {
      var _props = this.props,
          _props$onSubmit = _props.onSubmit,
          onSubmit = _props$onSubmit === undefined ? console.log : _props$onSubmit,
          cart = _props.cart,
          updateCartItem = _props.updateCartItem,
          loading = _props.loading,
          disabled = _props.disabled,
          style = _props.style,
          components = _props.components,
          otherProps = objectWithoutProperties(_props, ['onSubmit', 'cart', 'updateCartItem', 'loading', 'disabled', 'style', 'components']);
      var View = components.View,
          Container = components.Container,
          Text = components.Text,
          Title = components.Title,
          CartItem = components.CartItem,
          Button = components.Button,
          SubmitButton = components.SubmitButton,
          UpdateCartItem = components.UpdateCartItem;


      var empty = !cart || !cart.items || !cart.items.length;
      var total = cart && !cart.items ? 0 : cart.items.reduce(totalPriceReducer, 0);
      var cartItems = cart && cart.items && cart.items.map(function (item, i) {
        return React.createElement(CartItem, {
          key: i,
          item: item,
          components: components,
          updateCartItem: updateCartItem
        });
      });

      if (loading) {
        return React.createElement(Loader, null);
      }

      return React.createElement(
        View,
        _extends({}, otherProps, { style: [styles.cartContainer].concat(style) }),
        !empty && React.createElement(
          Container,
          null,
          React.createElement(
            Title,
            null,
            format(total)
          ),
          React.createElement(
            View,
            null,
            cartItems
          )
        ),
        React.createElement(SubmitButton, { onClick: function onClick() {
            return onSubmit(cart);
          } })
      );
    };

    return Cart;
  }(React.PureComponent);

  var styles = {
    cartContainer: {
      flex: 1
    }
  };

  var Cart$1 = withComponents(Cart);

  var Provider = componentsContext.Provider;

  var PdvProvider = function (_React$PureComponent) {
    inherits(PdvProvider, _React$PureComponent);

    // static state = {
    //     components: null
    // }

    // static getDerivedStateFromProps(props, state) {
    //     return {
    //         ...state,
    //         ...props
    //     }
    // }
    function PdvProvider(props) {
      classCallCheck(this, PdvProvider);

      var _this = possibleConstructorReturn(this, _React$PureComponent.call(this, props));

      var components = props.components;

      _this.state = {
        components: _extends({}, defaults$1, components)
      };
      return _this;
    }

    PdvProvider.prototype.render = function render() {
      var children = this.props.children;
      var components = this.state.components;

      return React.createElement(
        Provider,
        { value: components },
        children
      );
    };

    return PdvProvider;
  }(React.PureComponent);

  var Defaults = _extends({}, defaults$2);

  exports.Defaults = Defaults;
  exports.Button = Button$1;
  exports.Cart = Cart$1;
  exports.PdvProvider = PdvProvider;
  exports.withComponents = withComponents;
  exports.format = format;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
